<template>
  <q-input
    :label="t('dates.begginingOfIsurance')"
    v-model="selectedStartDate"
    class="q-mb-md"
    lazy-rules
    :rules="[testStartDate]"
    debounce="800"
    outlined
    mask="##.##.####"
    :error="!isCorrectStartDate"
    :error-message="startDateErrorMsg"
  >
    <template v-slot:append>
      <q-icon name="event" class="cursor-pointer">
        <q-popup-proxy cover transition-show="scale" transition-hide="scale">
          <q-date
            v-model="selectedStartDate"
            :options="dateOptions"
            mask="DD.MM.YYYY"
          >
            <div class="row items-center justify-end">
              <q-btn v-close-popup label="Close" color="primary" flat />
            </div>
          </q-date>
        </q-popup-proxy>
      </q-icon>
    </template>
  </q-input>
  <q-input
    v-if="selectedInsuranceType == t('possibleInsuranceTypeOptions.shortTime')"
    lazy-rules
    :rules="[testEndDate]"
    debounce="800"
    :label="t('dates.endOfIsurance')"
    outlined
    v-model="selectedEndDate"
    :error="!isCorrectEndDate"
    mask="##.##.####"
    :error-message="endDateErrorMsg"
  >
    <template v-slot:append>
      <q-icon name="event" class="cursor-pointer">
        <q-popup-proxy cover transition-show="scale" transition-hide="scale">
          <q-date
            v-model="selectedEndDate"
            :options="dateOptions"
            mask="DD.MM.YYYY"
          >
            <div class="row items-center justify-end">
              <q-btn v-close-popup label="Close" color="primary" flat />
            </div>
          </q-date>
        </q-popup-proxy>
      </q-icon>
    </template>
  </q-input>
</template>

<script setup lang="ts">
import {
  computed,
  defineEmits,
  defineProps,
  ref,
  watch,
  withDefaults,
} from 'vue';
import { validateDate } from 'src/utils/validateDates';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();

type Props = {
  selectedInsuranceType: string | null;
  isCorrectStartDate: boolean;
  isCorrectEndDate: boolean;
  selectedStartDate: string | null;
  selectedEndDate: string | null;
};
const props = withDefaults(defineProps<Props>(), {
  selectedInsuranceType: null,
  isCorrectStartDate: true,
  isCorrectEndDate: true,
  selectedStartDate: null,
  selectedEndDate: null,
});
interface Emits {
  (e: 'update:isCorrectStartDate', value: boolean): void;
  (e: 'update:daysCount', value: number): void;
  (e: 'update:selectedStartDate', value: string): void;
  (e: 'update:selectedEndDate', value: string): void;
}
const emit = defineEmits<Emits>();
const today = new Date().toISOString().substr(0, 10);

const selectedStartDate = computed({
  get() {
    return props.selectedStartDate;
  },
  set(newVal: selectedStartDate) {
    emit('update:selectedStartDate', newVal);
  },
});
const selectedEndDate = computed({
  get() {
    return props.selectedEndDate;
  },
  set(newVal: selectedEndDate) {
    emit('update:selectedEndDate', newVal);
  },
});
const startDateErrorMsg = ref<string | null>(null);
const endDateErrorMsg = ref<string | null>(null);

const stringToDate = (dateString: string): Date => {
  const [day, month, year] = dateString.split('.');
  return new Date(parseInt(year), parseInt(month) - 1, parseInt(day));
};
const daysCount = computed(() => {
  if (selectedStartDate.value && selectedEndDate.value) {
    const startDate = stringToDate(selectedStartDate.value);
    const endDate = stringToDate(selectedEndDate.value);
    return Math.floor(
      (endDate.getTime() - startDate.getTime()) / (1000 * 60 * 60 * 24)
    );
  }
  return 0;
});

const testStartDate = () => {
  const result = validateDate(selectedStartDate.value);
  if (typeof result === 'string') {
    startDateErrorMsg.value = result;
    emit('update:isCorrectStartDate', false);
    return false;
  } else {
    startDateErrorMsg.value = null;
    return true;
  }
};

const testEndDate = () => {
  const result = validateDate(selectedEndDate.value);
  if (typeof result === 'string') {
    endDateErrorMsg.value = result;
    return false;
  } else {
    endDateErrorMsg.value = null;
    return true;
  }
};

const dateOptions = (date: string) => new Date(date) >= new Date(today);

watch([selectedStartDate, selectedEndDate], (newVals, oldVals) => {
  if (newVals[1] < newVals[0]) {
    emit('update:isCorrectStartDate', false);
  } else {
    emit('update:isCorrectStartDate', true);
  }
});
watch(daysCount, (newVal) => {
  emit('update:daysCount', newVal + 1);
});
</script>

<style scoped></style>
